﻿#requires -version 4.0


Function Write-CSVLog {
[cmdletbinding()]
Param(
[Parameter(Position=0,Mandatory,ValueFromPipeline)]
[string]$Message,
[Parameter(Mandatory,HelpMessage = "What is the path to the CSV file?")]
[string]$Path
)

Begin {
    Write-Verbose "Starting: $($MyInvocation.Mycommand)"  
    Write-Verbose "Status: logging to $Path"
} #begin

Process {

    [pscustomobject]@{
    Date = Get-Date
    User = "$env:userdomain\$env:USERNAME"
    Message = $Message
    Script = $MyInvocation.ScriptName
    Line = $MyInvocation.ScriptLineNumber
    } | Export-CSV -Path $path -Encoding ASCII -Append

} #process

End {
    Write-Verbose "Ending: $($MyInvocation.Mycommand)"
} #end

} #end function

Function Import-CSVLog {

[cmdletbinding()]
Param(
[Parameter(Position=0,Mandatory,HelpMessage = "Enter the name of your CSV log")]
[ValidateScript({
if (Test-Path $_) {
   $True
}
else {
   Throw "Cannot validate path $_"
}
})]
[string]$Path      
)

Write-Verbose "Importing $path"
Import-CSV -Path $path | Select @{Name="Date";Expression={$_.Date -as [datetime]}},
User,Message,Script,@{Name="Line";Expression={$_.line -as [int]}}

}

#Import-csvlog c:\work\test.csv -Verbose | format-table