﻿#requires -version 5.0

#demo Write-Information

#need to run on a v5 system
enter-pssession chi-test01

help Write-Information

$InformationPreference
$InformationPreference = "continue"
#save results to a variable
write-information -MessageData "I am important" -Tags Demo,Summit -InformationAction Continue -InformationVariable inf

$inf | Select *

Function TestMe {
[cmdletbinding()]
Param()

#don't display the information message

#common parameter aliases not complete across v5 installs
Write-Information -informationaction SilentlyContinue -iv +inf -MessageData "Getting Windows Features" -Tags Status
(Get-WindowsFeature).Where({$_.installed})
Write-Information -informationaction SilentlyContinue -iv +inf -MessageData "Finished Windows Features" -Tags Status


}

TestMe

$inf

#just another type of object
$inf | get-member

$inf | sort TimeGenerated | Select TimeGenerated,MessageData,User,Computer

#you could export to create an audit trail
#as CSV
$inf | sort TimeGenerated | Select TimeGenerated,MessageData,User,Computer |
Export-CSV infotrail.csv


#as text
$inf | sort TimeGenerated | foreach {
"{0} [{4}:{2}] {1} ({3})" -f $_.timegenerated,$_.messagedata,$_.user,($_.tags -join ","),$_.Computer

} | Out-file infolog.txt -encoding ascii

get-content .\infolog.txt

#can also use write-host and use color to distinguish information
#but no tags it seems
Write-Host "The demo is complete" -InformationAction Continue -ForegroundColor Green -iv z
$z | select *
